// MoI Nodeedit
// Construct v.0.6 - Karsten, Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com

(function () {
//Sweep
    function Sweep()
    {
//        this.addInput("Profiles", "objectlist");
//        this.addInput("Rails", "objectlist");
        this.addOutput("Out", "objectlist");
//        this.properties = {mode:["Long","Long","Short"], Twist: ['freeform', 'freeform', 'flat'], pointy_ends: ['none', 'none', 'pointyend', 'pointystart', 'pointystartandend'], cap_ends: ["On", "On", "Off"], profiles: ['Auto', 'Auto', 'Exact', 'Refit', 'NumPoints'], numPts: [12]};
        this.properties = {P_Seq: ["abcabc", "abcabc", "aabbcc"], Twist: ['freeform', 'freeform', 'flat'], pointy_ends: ['none', 'none', 'pointyend', 'pointystart', 'pointystartandend'], cap_ends: ["On", "On", "Off"], profiles: ['Auto', 'Auto', 'Exact', 'Refit', 'NumPoints'], numPts: [12]};
    }
    Sweep.title = "Sweep";
    Sweep.desc = "Sweep";

    Sweep.prototype.getExtraMenuOptions = function ()
    {
        var that = this;
        return [
            {content: lang.getTranslation("single rail"), callback: function () {
                    if (that.inputs.length === 3) {
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
                        that.addInput("Profiles", "objectlist");
                        that.addInput("rails", "objectlist");
                    }
                }},
            {content: lang.getTranslation("two rail"), callback: function () {
                    if (that.inputs.length === 2) {
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
                        that.addInput("Profiles", "objectlist");
                        that.addInput("first rails", "objectlist");
                        that.addInput("second rails", "objectlist");
                    }
                }}
        ];
    }

    Sweep.prototype.onAdded = function ()
    {
        if (this.inputs.length === 0) {
            this.addInput("Profiles", "objectlist");
            this.addInput("rails", "objectlist");
        }

    }

    Sweep.prototype.onExecute = function ()
    {
        if (this.inputs.length === 2) {
            var inProfiles = this.getInputData(0, moi.geometryDatabase.createObjectList());
            var inProfLen=inProfiles.length;
            var inRails = this.getInputData(1, moi.geometryDatabase.createObjectList());
            var inRailLen=inRails.length;
            if (inRailLen > 0 && inProfLen > 0) {
                var prRatio = inProfLen / inRailLen;
                var IntprRatio = Math.floor(prRatio);
                if (IntprRatio <= 1) { //single profile matches to single rail
                    var data = this.processInOut("Short", this.multiProcess, null, null);
                    this.setOutputData(0, data.outputs[0]);
                } else { //two or more profiles to single rail
                    var out = moi.geometryDatabase.createObjectList();
                    if (IntprRatio >= 2) {
                        for (var i = 0; i < inRailLen; i++) {
                            var swp = moi.geometryDatabase.createObjectList();
                            var rail = moi.geometryDatabase.createObjectList();
                            rail.addObject(inRails.item(i));
                            var profiles = moi.geometryDatabase.createObjectList();
                            if (this.properties.P_Seq[0] === "abcabc") {
                                for (var j = 0; j < IntprRatio; j++)
                                    profiles.addObject(inProfiles.item(j + i * IntprRatio));
                            } else {
                                for (var j = 0; j < IntprRatio; j++) {
                                    profiles.addObject(inProfiles.item(j * inRailLen + i));
                                }
                            }

                            swp = factory('sweep', profiles, rail, null, null, this.properties.pointy_ends[0], this.properties.Twist[0], null, this.properties.cap_ends[0] === "On", null, null, this.properties.profiles[0], this.properties.numPts);
                            if(swp.length>0)out.addObject(swp.item(0));
                        }

                    }
                    this.setOutputData(0, out);
                }
            }

        } else { //two rails
            var out = moi.geometryDatabase.createObjectList();
            var inProfiles = this.getInputData(0, moi.geometryDatabase.createObjectList());
            var inProfLen=inProfiles.length;
            var inRail0 = this.getInputData(1, moi.geometryDatabase.createObjectList());
            var inRail0Len=inRail0.length;
            var inRail1 = this.getInputData(2, moi.geometryDatabase.createObjectList());
 
            if (inRail0Len > 0 && inRail1.length > 0 && inProfLen > 0) {
                if (inRail0Len === inRail1.length) {
                    var prRatio = inProfLen / inRail0Len;
                    var IntprRatio = Math.floor(prRatio);


                        for (var i = 0; i < inRail0Len; i++) {
                            var swp = moi.geometryDatabase.createObjectList();
                            var rails = moi.geometryDatabase.createObjectList();
                            rails.addObject(inRail0.item(i));
                            rails.addObject(inRail1.item(i));
                            var profiles = moi.geometryDatabase.createObjectList();
                            if (this.properties.P_Seq[0] === "abcabc") {
                                for (var j = 0; j < IntprRatio; j++)
                                    profiles.addObject(inProfiles.item(j + i * IntprRatio));
                            } else {
                                for (var j = 0; j < IntprRatio; j++) {
                                    profiles.addObject(inProfiles.item(j * inRail0Len + i));
                                }
                            }

                            swp = factory('sweep', profiles, rails, null, null, this.properties.pointy_ends[0], this.properties.Twist[0], null, this.properties.cap_ends[0] === "On", null, null, this.properties.profiles[0], this.properties.numPts);
                            if(swp.length>0)out.addObject(swp.item(0));
                        }


             }
            }
        this.setOutputData(0, out);
        }
    }
    Sweep.prototype.multiProcess = function (inProfiles, inRails)
    {
        var output = factory('sweep', inProfiles, inRails, null, null, this.properties.pointy_ends[0], this.properties.Twist[0], null, this.properties.cap_ends[0] === "On", null, null, this.properties.profiles[0], this.properties.numPts);
        return [output];
    }
    Sweep.prototype.onApply = function ()
    {
    }
    LiteGraph.registerNodeType("Construct2/Sweep", Sweep);

// ############ Blend ############
/////////////////////////////////////////////////////////

    function Blend()
    {
        this.size = [60, 20];
        this.addInput("Face0", "objectlist");
        this.addInput("Face1", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '', edge0: '', edge1: '', continuity: ['G1', 'G1', 'G2'], bulge: 1};
        this.selectedEdges = moi.geometryDatabase.createObjectList();
    }

    Blend.title = "Blend";
    Blend.desc = "Blend";
    Blend.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }

    Blend.prototype.onMouseDown = function () //reselection of the faces for the bridge
    {
        this.selectedEdges = moi.geometryDatabase.createObjectList();
        this.selectedEdges = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if ((this.selectedEdges.length > 1)
                && (this.selectedEdges.item(0).name != '')
                && (this.selectedEdges.item(1).name != '')
                )
        {
            this.properties.edge0 = this.selectedEdges.item(0).name; //storing the names of the selected objects
            this.properties.edge1 = this.selectedEdges.item(1).name;
            this.onExecute();
        }
    }

    Blend.prototype.onPropertyChange = function ()
    {
//        this.inputobjects = selectBylist(this.properties.faces);  //very important for for update on change
        /*      this.inputobjects = moi.geometryDatabase.createObjectList();
         moi.geometryDatabase.deselectAll();
         moi.geometryDatabase.selectNamed(this.properties.edge0);
         moi.geometryDatabase.selectNamed(this.properties.edge1);
         this.inputobjects = moi.geometryDatabase.getSelectedObjects();
         moi.geometryDatabase.deselectAll();
         this.outputs[0].label = this.properties.objName;
         this.computeSize();
         */
    }
    Blend.prototype.onAdded = function ()
    {
        this.selectedEdges = moi.geometryDatabase.createObjectList();
        this.properties.objName = getUID(6); // basename for the Blend faces
        this.selectedEdges = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if ((this.selectedEdges.length > 1)
                && (this.selectedEdges.item(0).name != '')
                && (this.selectedEdges.item(1).name != '')
                )
        {

            this.properties.edge0 = this.selectedEdges.item(0).name; //storing the names of the selected objects
            this.properties.edge1 = this.selectedEdges.item(1).name;
        }
    }

    Blend.prototype.onApply = function ()
    {

    }

    Blend.prototype.onExecute = function ()
    {   // cleaning up old faces
        var bRep0 = this.getInputData(0, moi.geometryDatabase.createObjectList()); // lists of the Facessets which connected by the bridge
        var bRep1 = this.getInputData(1, moi.geometryDatabase.createObjectList());
        var nakedEdges0 = moi.geometryDatabase.createObjectList();
        var nakedEdges1 = moi.geometryDatabase.createObjectList();
        var blendEdges = moi.geometryDatabase.createObjectList();
        var blendOut = moi.geometryDatabase.createObjectList();
        if (this.properties.edge0 != '' && this.properties.edge1 != '' && bRep0.length == 1 && bRep1.length == 1)
        {
            nakedEdges0 = bRep0.item(0).getNakedEdges();
            nakedEdges1 = bRep1.item(0).getNakedEdges();
            for (var n = 0; n < nakedEdges0.length; n++)
            {
                if (nakedEdges0.item(n).name == this.properties.edge0 || nakedEdges0.item(n).name == this.properties.edge1)
                    blendEdges.addObject(nakedEdges0.item(n));
            }
            for (var n = 0; n < nakedEdges1.length; n++)
            {
                if (nakedEdges1.item(n).name == this.properties.edge0 || nakedEdges1.item(n).name == this.properties.edge1)
                    blendEdges.addObject(nakedEdges1.item(n));
            }

//        moi.UI.alert(blendEdges.length, "Number of blendedges");
            var blendFac = moi.command.createFactory('blend');
            blendFac.setInput(0, blendEdges);
            blendFac.setInput(2, this.properties.continuity[0]);
            blendFac.setInput(3, this.properties.bulge);
//        var blendOut = blendFac.calculate();
            blendOut = blendFac.calculate();
            blendFac.cancel();
            blendOut.addObject(bRep0.item(0));
            blendOut.addObject(bRep1.item(0));
//        this.setOutputData(0, blendOut);
        }
        this.setOutputData(0, blendOut);
    }

    Blend.prototype.onApply = function ()
    {

    }


    Blend.prototype.onDrawBackground = function (ctx)
    {
        this.inputs[0].label = this.properties.edge0;
        this.inputs[1].label = this.properties.edge1;
    }
    LiteGraph.registerNodeType("Construct2/Blend", Blend);
    /////////////////////////////////////////////////////////

    function Fillet()
    {
        this.size = [60, 20];
        this.addInput("Brep", "objectlist");
        this.addInput("Radius", "numarray");
        this.addOutput("Out1", "objectlist");
        this.addOutput("adjacentFaces", "objectlist");
        this.internal = {filletEdgeNames: [0]};
        this.properties = {objName: '', radius: [1], continuity: ['Circular', 'Circular', 'ConstantDistance', 'G1', 'G2', 'G3'], bulge: 1, radiuscheck: ["On", "On", "Off"], savetolerance: 0.1};
        this.selectedEdges = moi.geometryDatabase.createObjectList();
        this.namesOK = false;
    }

    Fillet.title = "Fillet";
    Fillet.desc = "Fillet";
    Fillet.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }

    Fillet.prototype.getExtraMenuOptions = function () {
        var that = this, thatgraph = this.graph;
        return [{content: lang.getTranslation("Update"), callback: function () {
                    that.onUpdate();
                    thatgraph.setisChangedFlag(that.id);
                }}];
    };

    Fillet.prototype.onUpdate = function () //reselection of the faces for the bridge
    {
        this.internal.filletEdgeNames = [0];
        this.onAdded();
//     this.onExecute();
    }
    /*
     Fillet.prototype.onMouseDown = function () //reselection of the faces for the bridge
     {
     this.selectedEdges = moi.geometryDatabase.createObjectList();
     this.selectedEdges = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
     if (this.selectedEdges.length > 0)
     {
     for (var i = 0; i < this.selectedEdges.length; i++)
     {
     if (this.selectedEdges.item(i).name != '')
     {
     this.properties.filletEdgeNames.push(this.selectedEdges.item(i).name); //storing the names of the selected objects
     this.namesOK = true;
     } else
     {
     this.namesOK = false;
     return this.namesOK;
     }
     
     }
     }
     
     this.onExecute();
     }
     */

    Fillet.prototype.onPropertyChange = function ()
    {

    }
    Fillet.prototype.onAdded = function ()
    {
        this.selectedEdges = moi.geometryDatabase.createObjectList();
        this.selectedEdges = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if (this.selectedEdges.length > 0)
        {
            for (var i = 0; i < this.selectedEdges.length; i++)
            {
                if (this.selectedEdges.item(i).name !== '')
                {
                    this.internal.filletEdgeNames.push(this.selectedEdges.item(i).name); //storing the names of the selected objects
                    this.namesOK = true;
                } else
                {
                    this.namesOK = false;
                    return this.namesOK;
                }
            }
        }
//                moi.UI.alert(this.internal.filletEdgeNames.length, "selected filletedges");
    }

    Fillet.prototype.onApply = function ()
    {

    }

    Fillet.prototype.onExecute = function ()
    {

        // cleaning up old faces
        var bRep0 = moi.geometryDatabase.createObjectList();
        bRep0 = this.getInputData(0, moi.geometryDatabase.createObjectList());
        this.properties.radius = this.getInputData(1, this.properties.radius);
        var filletEdges = moi.geometryDatabase.createObjectList();
        var brepEdges = moi.geometryDatabase.createObjectList();
        var filletOut = moi.geometryDatabase.createObjectList();
        var adjacentFaces = moi.geometryDatabase.createObjectList();
        if (bRep0.length > 0)
        {
            brepEdges = bRep0.item(0).getEdges();

            for (var n = 1; n < this.internal.filletEdgeNames.length; n++) //start with one caused by the leading 0
            {
                for (var i = 0; i < brepEdges.length; i++)
                {
                    if (brepEdges.item(i).name == this.internal.filletEdgeNames[n])
                        filletEdges.addObject(brepEdges.item(i));

                }
            }
        }
        if (this.properties.bulge < 0.5)
            this.properties.bulge = 0.5;
        if (this.properties.bulge > 2.0)
            this.properties.bulge = 2.0;
//////////////////
        if (filletEdges.length > 0)
        {
            for (var n = 0; n < filletEdges.length; n++)
            {
                var singleEdgeFaces = filletEdges.item(n).getFacesOfEdge();
                for (var i = 0; i < singleEdgeFaces.length; i++)
                {
                    adjacentFaces.addObject(singleEdgeFaces.item(i));
                }
            }
        }
///////////////////




// radiuscheck
        if (this.properties.radiuscheck[0] === "On")
        {
            var edgeRadius = evalMinR(filletEdges, 100);
//            moi.UI.alert(edgeRadius, "EdgeRadius");
            if (edgeRadius < this.properties.radius[0])
                this.properties.radius[0] = Math.abs(edgeRadius - this.properties.savetolerance);
        } else {
            moi.UI.alert("Hello User,switch of the radiuscheck is danger! A bigger radius than the radius of the selected curves will crash Moi! Use it only if you can control that", "Warning");
        }
//end radiuscheck

//        moi.UI.alert(filletEdges.length, "Number of filletedges");
        var filletFac = moi.command.createFactory('fillet');
        filletFac.setInput(0, filletEdges);
        filletFac.setInput(1, false); //straigth corners
//                filletFac.setInput(2, false); //corners ????
        filletFac.setInput(3, this.properties.radius[0]);
        filletFac.setInput(4, this.properties.continuity[0]);
        filletFac.setInput(5, this.properties.bulge);
//filletFac.update();
//filletOut = filletFac.getCreatedObjects();
//filletFac.commit();
        filletOut = filletFac.calculate();
        filletFac.cancel();

        this.setOutputData(0, filletOut);
        this.setOutputData(1, adjacentFaces);
    }

    Fillet.prototype.onApply = function ()
    {

    }

    Fillet.prototype.onDrawBackground = function (ctx)
    {
//        this.inputs[0].label = this.properties.edge0;
        this.inputs[1].label = this.properties.radius;
    }
    LiteGraph.registerNodeType("Construct2/Fillet", Fillet);
// offset
    function  offset()
    {
        this.addInput("Object", "objectlist");
        this.addInput("Distance", "numarray");
        this.addOutput("Object", "objectlist");
        this.addOutput("Frame", "pointarray");
        this.properties = {mode: ["Long", "Long", "Long+", "Short", "Short+"], dist: [1], corners: ['round', 'round', 'sharp'], trim: ["No", "No", "Yes"], flip: ["No", "No", "Yes"], both: ["No", "No", "Yes"], caps: ["No", "No", "Yes"]};
    }

    offset.title = " offset";
    offset.desc = " offset";

    offset.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, this.properties.dist);
        this.properties.dist = data.inputs[1];

        this.setOutputData(0, data.outputs[0]);
        this.setOutputData(1, data.outputs[1]);

    }

    offset.prototype.multiProcess = function (obj, dist)
    {

        var out = [];
        var frm = new pointArray(false);
//       out[0] = factory('offset', obj, dist, frame ,'sharp',true, null,false,false);
        var ofFac = moi.command.createFactory('offset');
        ofFac.setInput(0, obj);
        var pln = ofFac.getCurvePlane();
        ofFac.setInput(1, dist);
        ofFac.setInput(2, pln);
        ofFac.setInput(3, this.properties.corners[0]); //corner type sharp round
        ofFac.setInput(4, this.properties.trim[0] === "Yes");    //trim
        ofFac.setInput(5, this.properties.flip[0] === "Yes");   //flip        
        ofFac.setInput(6, this.properties.both[0] === "Yes");   //both sides
        ofFac.setInput(7, this.properties.caps[0] === "Yes");   //cap ends
        out[0] = ofFac.calculate();
        ofFac.cancel();
//        frm.pushFrame(pln);
        if (this.properties.flip[0] === "Yes" && this.properties.both[0] === "No" && (obj.item(0).type === 1 || obj.item(0).type === 2)) {
            frm.pushFrame(pln);
            /*      var hfFac = moi.command.createFactory('offset');
             hfFac.setInput(0, out[0]);
             var hlpPln=hfFac.getCurvePlane();
             hfFac.cancel();*/
            //       var flpPt=addVec(pln.origin,scaleVec(substrVec(pln.origin,hlpPln.origin),dist*2));
            var flpPt = addVec(pln.origin, scaleVec(substrVec(pln.origin, addVec(obj.item(0).getStartPt(), scaleVec(substrVec(obj.item(0).getEndPt(), obj.item(0).getStartPt()), 0.5))), dist * 10));
            var flpPln = moi.VectorMath.createFrame(flpPt, pln.xaxis, pln.yaxis);
            var ofFac = moi.command.createFactory('offset');
            ofFac.setInput(0, obj);
            var pln = ofFac.getCurvePlane();
            ofFac.setInput(1, dist);
            ofFac.setInput(2, flpPln);
            ofFac.setInput(3, this.properties.corners[0]); //corner type sharp round
            ofFac.setInput(4, this.properties.trim[0] === "Yes");    //trim
//        ofFac.setInput(5, this.properties.flip[0]==="Yes");   //flip        
            ofFac.setInput(6, this.properties.both[0] === "Yes");   //both sides
            ofFac.setInput(7, this.properties.caps[0] === "Yes");   //cap ends
            out[0] = ofFac.calculate();
            ofFac.cancel();
            frm.pushFrame(flpPln);
        }
        out[1] = frm;
        return out;
    }

    LiteGraph.registerNodeType("Construct2/ offset", offset);

    function mLoft()
    {
        this.addInput("In", "objectlist");
        this.addInput("Starts", "pointarray");
        this.addInput("Targets", "pointarray");
        this.addOutput("Out", "objectlist");
        this.properties = { style: ["Loose", "Normal", "Loose", "Straight"], cap_ends: ["On", "On", "Off"], closed: ["Off", "On", "Off"]};
    }

    mLoft.title = "mLoft";
    mLoft.desc = "mLoft";

    mLoft.prototype.onExecute = function ()
    {
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var starts = this.getInputData(1, new pointArray(true));
        var targets = this.getInputData(2, new pointArray(true));
        var output = moi.geometryDatabase.createObjectList();
//        if (this.properties.mode[0] === "Single") {
   if (inObj.length > 1) {
        if (targets.length>1) {
                /// Fill up the starts if only a default startframe is present to process later in general
                var sframes = [starts.getFrame(0)];
                for (var i = 1; i < inObj.length; i++) {
                    if ((starts.length -1) >= i) {
                        sframes.push(starts.getFrame(i));
                    } else {
                        sframes.push(sframes[sframes.length - 1]);
                    }
                }
//                moi.UI.alert(sframes.length, "sframes.length");
                if (targets.xlength > inObj.length) {
                    var cpl = inObj.length;
                } else {
                    var cpl = targets.xlength;
                } //cpl curves per loft - decision if more objects than targets in a sequence of points
//                moi.UI.alert(cpl, "cpl");
                for (var i = 0; i < targets.zlength; i++) {
                    var crvs = moi.geometryDatabase.createObjectList();
                    for (var j = 0; j < cpl; j++) {
                        var crv = moi.geometryDatabase.createObjectList();
                        crv.addObject(inObj.item(j));
                        var hcrv = factory('orient', crv, sframes[j], targets.getFrame(j + i * targets.xlength), true);
                        crvs.addObject(hcrv.item(0));
                    }
                    var hloft = factory('loft', crvs, null, this.properties.style[0], this.properties.cap_ends[0] === "On", this.properties.closed[0] === "On", "Exact");
                    output.addObject(hloft.item(0));
                }
            
        }else{
                output = factory('loft', inObj, null, this.properties.style[0], this.properties.cap_ends[0] === "On", this.properties.closed[0] === "On", "Exact");
            }
        }
            this.setOutputData(0, output); 
    }

    LiteGraph.registerNodeType("Construct2/mLoft", mLoft);
    ////////////////////////
        function mLoft2()
    {
        this.labels = "abcdef";
        this.size = [60, 20];
//        this.dynamicInternal = ["a", "b", "c", "d", "e", "f"];
        this.internal = {a: [], b: []};
//        this.internal = {};
//        this.addOutput("Out", "numarray");
        this.zero = [0];
        this.properties = {style: ["Loose", "Normal", "Loose", "Straight"], cap_ends: ["On", "On", "Off"], closed: ["Off", "On", "Off"]};
    }

    mLoft2.title = "mLoft2";
    mLoft2.desc = "mLoft2";

    mLoft2.prototype.getExtraMenuOptions = function ()
    {
        var that = this;
        return [

            {content: lang.getTranslation("normal"), callback: function () {
                    if (that.inputs[1].type !== "pointarray") {
                        var n = that.inputs.length;
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
//                        for (var i = 0; i < n; i++)
                        that.addInput("Crvs", "objectlist");
                        that.addInput("Starts", "pointarray");
                        that.addInput("Targets", "pointarray");
//                        that.removeOutput(0, "");
//                        that.addOutput("Out", "pointarray");
                    }
                }},
            {content: lang.getTranslation("Curves"), callback: function () {
//                    if (that.inputs[1].type !== "objectlist") {
                    var n = that.inputs.length;
                    for (var i = that.inputs.length - 1; i >= 0; i--)
                        that.removeInput(i, "");
                    for (var i = 0; i < n; i++)
                        that.addInput("Crvs", "objectlist");
//                        that.removeOutput(0, "");
//                        that.addOutput("Out", "objectlist");
//                    }
                }}
        ];
    }

    mLoft2.prototype.onGetInputs = function ()
    {
        var inpName = "";
        var list = [];
        if (this.inputs[0].type === "objectlist")
            inpName = "Crvs";

        list.push([inpName, this.inputs[1].type, {locked: true}]);

        return list;
    }

    mLoft2.prototype.onInputAdded = function (inp)
    {
        this.internal[inp.name] = 1;
        for (var i in this.inputs)
            this.inputs[i].locked = true;
        if (i > 1)
            this.inputs[i].locked = false;
    }

    mLoft2.prototype.onInputRemoved = function (slot, name)
    {   //if(this.inputs[0].type==="objectlist"){
        if (this.internal[name])
            delete this.internal[name];
        for (var i in this.inputs)
            this.inputs[i].locked = true;
        if (this.inputs.length > 2)
            this.inputs[i].locked = false;
        //       }
    }

    mLoft2.prototype.onAdded = function ()
    {
        for (var i = 0; i < this.labels.length; i++)
            if (this.internal[this.labels.charAt(i)] && this.inputs.length === i)
            this.addInput("Crvs", "objectlist");
/*            if(this.inputs.length===0){
            this.addInput("Crvs", "objectlist");
            this.addInput("Crvs", "objectlist");
            }*/
        if (this.outputs.length === 0)
            this.addOutput("Out", "objectlist");
//        this.addInput("In", "objectlist");
//        this.addInput("Starts", "pointarray");
//        this.addInput("Targets", "pointarray");
//        this.addOutput("Out", "objectlist");
        this.setDirtyCanvas(true);
    }

    mLoft2.prototype.onExecute = function ()
    {
        var output = moi.geometryDatabase.createObjectList();
        if (this.inputs[1].type === "pointarray") {
            var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
            var starts = this.getInputData(1, new pointArray(true));
            var targets = this.getInputData(2, new pointArray(true));
//        var output = moi.geometryDatabase.createObjectList();
//        if (this.properties.mode[0] === "Single") {
            if (inObj.length > 1) {
                if (targets.length > 1) {
                    /// Fill up the starts if only a default startframe is present to process later in general
                    var sframes = [starts.getFrame(0)];
                    for (var i = 1; i < inObj.length; i++) {
                        if ((starts.length - 1) >= i) {
                            sframes.push(starts.getFrame(i));
                        } else {
                            sframes.push(sframes[sframes.length - 1]);
                        }
                    }
//                moi.UI.alert(sframes.length, "sframes.length");
                    if (targets.xlength > inObj.length) {
                        var cpl = inObj.length;
                    } else {
                        var cpl = targets.xlength;
                    } //cpl curves per loft - decision if more objects than targets in a sequence of points
//                moi.UI.alert(cpl, "cpl");
                    for (var i = 0; i < targets.zlength; i++) {
                        var crvs = moi.geometryDatabase.createObjectList();
                        for (var j = 0; j < cpl; j++) {
                            var crv = moi.geometryDatabase.createObjectList();
                            crv.addObject(inObj.item(j));
                            var hcrv = factory('orient', crv, sframes[j], targets.getFrame(j + i * targets.xlength), true);
                            crvs.addObject(hcrv.item(0));
                        }
                        var hloft = factory('loft', crvs, null, this.properties.style[0], this.properties.cap_ends[0] === "On", this.properties.closed[0] === "On", "Exact");
                        output.addObject(hloft.item(0));
                    }

                } else {
                    output = factory('loft', inObj, null, this.properties.style[0], this.properties.cap_ends[0] === "On", this.properties.closed[0] === "On", "Exact");
                }
            }
        }
        if (this.inputs[1].type === "objectlist") {
            var inArray = [];
            var minLength = null;
            for (var i = 0; i < this.inputs.length; i++)
            {
                var inp = this.getInputData(i, moi.geometryDatabase.createObjectList());
                if (minLength === null && inp.length > 1) {
                    minLength = inp.length;
                } else {
                    if (inp.length < minLength && inp.length > 1)
                        minLength = inp.length;
                }
                if (inp.length > 1)
                    inArray.push(inp);
            }
//            moi.UI.alert(inArray.length, "inArray.length");
//            moi.UI.alert(minLength, "minlength");
            if (minLength !== null && inArray.length > 1)
                for (var j = 0; j < minLength; j++) {
                    var lcrvs = moi.geometryDatabase.createObjectList();
                    for (var k = 0; k < inArray.length; k++) {
                        lcrvs.addObject(inArray[k].item(j))
                    }
//                                            moi.UI.alert(lcrvs.length, "lcrvs.length");
                    var hloft = factory('loft', lcrvs, null, this.properties.style[0], this.properties.cap_ends[0] === "On", this.properties.closed[0] === "On", "Exact");
                    output.addObject(hloft.item(0));
                }
        }
        this.setOutputData(0, output);
    }

    LiteGraph.registerNodeType("Construct2/mLoft2", mLoft2);
    
// Planar
function Planar()
{
this.addInput("In","objectlist");
this.addOutput("Out","objectlist");
}

Planar.title = "Planar";
Planar.desc = "Planar";

Planar.prototype.onExecute = function()
{
var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
var output = moi.geometryDatabase.createObjectList();
if ( inObj.length> 0 ) output = factory ('planarsrf', inObj);
this.setOutputData(0, output);
}

LiteGraph.registerNodeType("Construct2/Planar", Planar);

//
    function isoCrvs()
    {
        this.addInput("Brep", "objectlist");
        this.addInput("nums", "numarray");
        this.addOutput("Out1", "objectlist");
        this.internal = {filletEdgeNames: [0]};
        this.properties = {Division: [6], Edge: ["E0","E0"]};
    }

    isoCrvs.title = "isoCrvs";
    isoCrvs.desc = "isoCrvs";
    isoCrvs.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }
    

    isoCrvs.prototype.onPropertyChange = function ()
    {
//              moi.UI.alert("onPropertyChange");

        var brepSurf = moi.geometryDatabase.createObjectList();
        brepSurf = this.getInputData(0, moi.geometryDatabase.createObjectList());

        if(brepSurf.length===0){this.properties.Edge["E0","E0"];}
        else{
            var subfaces=brepSurf.item(0).getFaces();
//            var face=subfaces.item(0);
            var edges=brepSurf.item(0).getEdges();
            if(edges.length!==this.properties.Edge.length-1){
    //                    moi.UI.alert(edges.length, "edges.length");
                this.properties.Edge=["E0","E0"];
                for(var i=1; i<edges.length;i++){ var item="E"; item+=i; this.properties.Edge.push(item);}
            }
        }
    }
    isoCrvs.prototype.onMouseEnter = function ()
    { /*       var brepSurf = moi.geometryDatabase.createObjectList();
        brepSurf = this.getInputData(0, moi.geometryDatabase.createObjectList());

        if(brepSurf.length===0){this.properties.Edge["E0","E0"];}
        else{
            var subfaces=brepSurf.item(0).getFaces();
            var face=subfaces.item(0);
            var edges=brepSurf.item(0).getEdges();
            if(edges.length!==this.properties.Edge.length-1){
    //                    moi.UI.alert(edges.length, "edges.length");
                this.properties.Edge=["E0","E0"];
                for(var i=1; i<edges.length;i++){ var item="E"; item+=i; this.properties.Edge.push(item);}
            }
        }*/
    
    }
    isoCrvs.prototype.onAdded = function ()
    {

    }

    isoCrvs.prototype.onExecute = function ()
    {
        var brepSurf = moi.geometryDatabase.createObjectList();
        brepSurf = this.getInputData(0, moi.geometryDatabase.createObjectList());
        this.properties.Division = this.getInputData(1, this.properties.Division);
        if(brepSurf.length===0){this.properties.Edge["E0","E0"];}
        else{
            var subfaces=brepSurf.item(0).getFaces();
            var face=subfaces.item(0);
            var edges=brepSurf.item(0).getEdges();
            if(edges.length!==this.properties.Edge.length-1){
    //                    moi.UI.alert(edges.length, "edges.length");
                this.properties.Edge=["E0","E0"];
                for(var i=1; i<edges.length;i++){ var item="E"; item+=i; this.properties.Edge.push(item);}
            }
            var idx = parseInt(this.properties.Edge[0].substr(1), 10);
            //    moi.UI.alert(this.properties.Edge[0].substr(1), "Number of edges");
            var startPt = edges.item(idx).getStartPt();
            var startPtObj = factory('point', startPt);

            if (this.properties.Division.length > 1)
            { var edge=moi.geometryDatabase.createObjectList();
                edge.addObject(edges.item(idx).clone());
                if(this.properties.Division[0]<0.001)this.properties.Division[0]=0.001/**this.properties.Division[this.properties.Division.length-1]*/;
                var ptArray = CurveDivision(edge.item(0), this.properties.Division, startPtObj, "Freeform");
            } else {
                var ptArray = factory('arraycurve', startPtObj, edges.item(idx), 'NumItems', this.properties.Division[0] + 2);
            }
    /*
               if (this.properties.DivNumRail.length > 1)
            {
                var framePts = CurveDiv(rails.item(i), this.properties.DivNumRail, bFramePts, this.properties.rotationMode[0]);                
            } else {
                var framePts = factory('arraycurve', bFramePts, rails.item(i), 'NumItems', this.properties.DivNumRail[0], null, this.properties.rotationMode[0]);
            }
     */    
//        var ptArray = factory('arraycurve', startPtObj, edges.item(idx), 'NumItems', this.properties.Division[0]+2);
        var pts=[];//pts.push(startPt);
        for(var k=0;k<ptArray.length;k++)pts.push(ptArray.item(k).pt); 
        //moi.UI.alert(pts.length, "pts");
        var crvs=moi.GeometryDatabase.createObjectList();
/*        var faces=edges.item(idx).getFacesOfEdge();
              moi.UI.alert(faces.length, "face");
              moi.UI.alert(pts.length, "pts");*/
//                      moi.UI.alert(face.type, "type");
        for(var j=0;j<pts.length;j++){
            
            var tempcrv = factory('isocurve',face, pts[j] ,"both");
//            moi.UI.alert(tempcrv.length, "tempcrvs");
            if(tempcrv.length>0)crvs.addObject(tempcrv.item(0));
        }
    }
        this.setOutputData(0, crvs);
    }

    isoCrvs.prototype.onApply = function ()
    {

    }

    isoCrvs.prototype.onDrawBackground = function (ctx)
    {
//        this.inputs[0].label = this.properties.edge0;
    }
    LiteGraph.registerNodeType("Construct2/isoCrvs", isoCrvs);
//


// Text

function Text()
{
	this.addInput("Base Point","pointarray");
        this.addInput("Text Height","numarray");
	this.addInput("Extrusion Height","numarray");
	this.addOutput("Out","objectlist");
	this.properties = { mode:["Long","Long","Short"], Font: ["Arial"],Bold:["No","No","Yes"],itallic:["No","No","Yes"], tHeight:[3.5],eHeight:[1.0],result:["solids","solids","surfaces","curves"],txt:"@'y'@"};
}

Text.title = "Text";
Text.desc = "Text";

Text.prototype.onExecute = function()
{
		var data = this.processInOut(this.properties.mode[0], this.multiProcess,null, this.properties.tHeight, this.properties.eHeight );
		this.setOutputData(0, data.outputs[0]);
}

Text.prototype.multiProcess = function(bPt,tH, eH)
{
	var frame = bPt.getFrame(0);
	return [factory ('text', frame,this.properties.txt, this.properties.Font[0],this.properties.Bold[0]==="Yes", this.properties.itallic[0]==="Yes",this.properties.result[0],tH,eH,false)];
}

Text.prototype.onAdded = function()
{
var tFac = moi.command.createFactory('text');
var FontList = tFac.getFonts();
for(var i=0;i<FontList.length;i++){
    this.properties.Font[i+1]=FontList.item(i);
}
tFac.cancel();
}
LiteGraph.registerNodeType("Construct2/Text", Text);


   
    // Numbering
function Numbering()
{	this.addInput("Numbers","numarray");
	this.addInput("Base Points","pointarray");
        this.addInput("Text Height","numarray");
	this.addInput("Extrusion Height","numarray");
	this.addOutput("Out","objectlist");
	this.properties = { mode:["Long","Long","Short"], Font: ["Arial"],Bolt:["No","No","Yes"],itallic:["No","No","Yes"], tHeight:[3.5],eHeight:[1.0],result:["solids","solids","surfaces","curves"],txt:[1]};
}

Numbering.title = "Numbering";
Numbering.desc = "Numbering";

Numbering.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess,this.properties.txt[0],null, this.properties.tHeight[0], this.properties.eHeight[0] );
        this.properties.txt = data.inputs[0];
        this.properties.tHeight = data.inputs[2];
        this.properties.eHeight = data.inputs[3];
    
        this.setOutputData(0, data.outputs[0]);
}

Numbering.prototype.multiProcess = function(txt,bPt,tH, eH)
{
	var frame = bPt.getFrame(0);
	return [factory ('text', frame,txt, this.properties.Font[0],this.properties.Bolt[0]==="Yes", this.properties.itallic[0]==="Yes",this.properties.result[0],tH,eH,false)];
}

Numbering.prototype.onAdded = function()
{
var tFac = moi.command.createFactory('text');
var FontList = tFac.getFonts();
for(var i=0;i<FontList.length;i++){
    this.properties.Font[i+1]=FontList.item(i);
}
tFac.cancel();
}
LiteGraph.registerNodeType("Construct2/Numbering", Numbering);
})();
